diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/phy-entity.h ns-3.43/src/wifi/model/phy-entity.h
--- ns-3.42/src/wifi/model/phy-entity.h	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/phy-entity.h	2024-10-09 16:41:10.124656700 -0700
@@ -1,32 +1,21 @@
 /*
  * Copyright (c) 2020 Orange Labs
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Rediet <getachew.redieteab@orange.com>
  *          Sébastien Deronne <sebastien.deronne@gmail.com> (for logic ported from wifi-phy and
- * spectrum-wifi-phy) Mathieu Lacage <mathieu.lacage@sophia.inria.fr> (for logic ported from
- * wifi-phy)
+ *                                                           spectrum-wifi-phy)
+ *          Mathieu Lacage <mathieu.lacage@sophia.inria.fr> (for logic ported from wifi-phy)
  */
 
 #ifndef PHY_ENTITY_H
 #define PHY_ENTITY_H
 
-#include "wifi-mpdu-type.h"
 #include "wifi-phy-band.h"
 #include "wifi-ppdu.h"
 #include "wifi-tx-vector.h"
+#include "wifi-types.h"
 
 #include "ns3/event-id.h"
 #include "ns3/nstime.h"
@@ -50,33 +39,12 @@
 namespace ns3
 {
 
-/// SignalNoiseDbm structure
-struct SignalNoiseDbm
-{
-    double signal; ///< signal strength in dBm
-    double noise;  ///< noise power in dBm
-};
-
-/// MpduInfo structure
-struct MpduInfo
-{
-    MpduType type;          ///< type of MPDU
-    uint32_t mpduRefNumber; ///< MPDU ref number
-};
-
-/// RxSignalInfo structure containing info on the received signal
-struct RxSignalInfo
-{
-    double snr;  ///< SNR in linear scale
-    double rssi; ///< RSSI in dBm
-};
-
 /**
- * A map of the received power (Watts) for each band
+ * A map of the received power for each band
  */
-using RxPowerWattPerChannelBand = std::map<WifiSpectrumBandInfo, double>;
+using RxPowerWattPerChannelBand = std::map<WifiSpectrumBandInfo, Watt_u>;
 
-class WifiPsdu;
+class WifiMpdu;
 class WifiPhy;
 class InterferenceHelper;
 class Event;
@@ -493,13 +461,13 @@
      *
      * \param txDuration the duration of the transmission
      * \param ppdu the PPDU to send
-     * \param txPowerDbm the total TX power in dBm
+     * \param txPower the total TX power
      * \param txPowerSpectrum the TX PSD
      * \param type the type of transmission (for logging)
      */
     void Transmit(Time txDuration,
                   Ptr<const WifiPpdu> ppdu,
-                  double txPowerDbm,
+                  dBm_u txPower,
                   Ptr<SpectrumValue> txPowerSpectrum,
                   const std::string& type);
 
@@ -510,19 +478,19 @@
      *
      * \return the total amount of time this PHY will stay busy for the transmission of the PPDU
      */
-    virtual Time CalculateTxDuration(WifiConstPsduMap psduMap,
+    virtual Time CalculateTxDuration(const WifiConstPsduMap& psduMap,
                                      const WifiTxVector& txVector,
                                      WifiPhyBand band) const;
     /**
-     * Return the CCA threshold in dBm for a given channel type.
+     * Return the CCA threshold for a given channel type.
      * If the channel type is not provided, the default CCA threshold is returned.
      *
      * \param ppdu the PPDU that is being received
      * \param channelType the channel type
-     * \return the CCA threshold in dBm
+     * \return the CCA threshold
      */
-    virtual double GetCcaThreshold(const Ptr<const WifiPpdu> ppdu,
-                                   WifiChannelListType channelType) const;
+    virtual dBm_u GetCcaThreshold(const Ptr<const WifiPpdu> ppdu,
+                                  WifiChannelListType channelType) const;
 
     /**
      * The WifiPpdu from the TX PHY is received by each RX PHY attached to the same channel.
@@ -695,7 +663,7 @@
     /**
      * Get the reception status for the provided MPDU and notify.
      *
-     * \param psdu the arriving MPDU formatted as a PSDU
+     * \param mpdu the arriving MPDU
      * \param event the event holding incoming PPDU's information
      * \param staId the station ID of the PSDU (only used for MU)
      * \param relativeMpduStart the relative start time of the MPDU within the A-MPDU.
@@ -704,7 +672,7 @@
      *
      * \return information on MPDU reception: status, signal power (dBm), and noise power (in dBm)
      */
-    std::pair<bool, SignalNoiseDbm> GetReceptionStatus(Ptr<const WifiPsdu> psdu,
+    std::pair<bool, SignalNoiseDbm> GetReceptionStatus(Ptr<WifiMpdu> mpdu,
                                                        Ptr<Event> event,
                                                        uint16_t staId,
                                                        Time relativeMpduStart,
@@ -713,13 +681,13 @@
      * The last symbol of an MPDU in an A-MPDU has arrived.
      *
      * \param event the event holding incoming PPDU's information
-     * \param psdu the arriving MPDU formatted as a PSDU containing a normal MPDU
+     * \param mpdu the arriving MPDU
      * \param mpduIndex the index of the MPDU within the A-MPDU
      * \param relativeStart the relative start time of the MPDU within the A-MPDU.
      * \param mpduDuration the duration of the MPDU
      */
     void EndOfMpdu(Ptr<Event> event,
-                   Ptr<const WifiPsdu> psdu,
+                   Ptr<WifiMpdu> mpdu,
                    size_t mpduIndex,
                    Time relativeStart,
                    Time mpduDuration);
@@ -769,9 +737,9 @@
      *
      * \param txVector the transmission parameters
      * \param staId the station ID of the PSDU
-     * \return a pair of channel width (MHz) and band
+     * \return a pair of channel width and band
      */
-    virtual std::pair<uint16_t, WifiSpectrumBandInfo> GetChannelWidthAndBand(
+    virtual std::pair<MHz_u, WifiSpectrumBandInfo> GetChannelWidthAndBand(
         const WifiTxVector& txVector,
         uint16_t staId) const;
 
@@ -799,13 +767,13 @@
      */
     SnrPer GetPhyHeaderSnrPer(WifiPpduField field, Ptr<Event> event) const;
     /**
-     * Obtain the received power (W) for a given band.
+     * Obtain the received power for a given band.
      * Wrapper used by child classes.
      *
      * \param event the event holding incoming PPDU's information
-     * \return the received power (W) for the event over a given band
+     * \return the received power for the event over a given band
      */
-    double GetRxPowerWForPpdu(Ptr<Event> event) const;
+    Watt_u GetRxPowerForPpdu(Ptr<Event> event) const;
     /**
      * Get the pointer to the current event (stored in WifiPhy).
      * Wrapper used by child classes.
@@ -836,7 +804,8 @@
      * \param duration the PPDU duration
      * \param rxPower received power per band (W)
      * \param isStartHePortionRxing flag whether the event corresponds to the start of the OFDMA
-     * payload reception (only used for UL-OFDMA) \return the created event
+     * payload reception (only used for UL-OFDMA)
+     * \return the created event
      */
     Ptr<Event> CreateInterferenceEvent(Ptr<const WifiPpdu> ppdu,
                                        Time duration,
@@ -868,27 +837,17 @@
     void NotifyInterferenceRxEndAndClear(bool reset);
 
     /**
-     * \param txPowerW power in W to spread across the bands
+     * \param txPower power to spread across the bands
      * \param ppdu the PPDU that will be transmitted
      * \return Pointer to SpectrumValue
      *
      * This is a helper function to create the right TX PSD corresponding
      * to the amendment of this PHY.
      */
-    virtual Ptr<SpectrumValue> GetTxPowerSpectralDensity(double txPowerW,
+    virtual Ptr<SpectrumValue> GetTxPowerSpectralDensity(Watt_u txPower,
                                                          Ptr<const WifiPpdu> ppdu) const = 0;
 
     /**
-     * Get the center frequency of the channel corresponding the current TxVector rather than
-     * that of the supported channel width.
-     * Consider that this "primary channel" is on the lower part for the time being.
-     *
-     * \param txVector the TXVECTOR that has the channel width that is to be used
-     * \return the center frequency in MHz corresponding to the channel width to be used
-     */
-    uint16_t GetCenterFrequencyForChannelWidth(const WifiTxVector& txVector) const;
-
-    /**
      * Fire the trace indicating that the PHY is starting to receive the payload of a PPDU.
      *
      * \param txVector the TXVECTOR used to transmit the PPDU
@@ -903,65 +862,64 @@
      * channel width). Otherwise, this call is equivalent to GetBand with
      * <i>bandIndex</i> equal to zero.
      *
-     * \param bandWidth the width of the band to be returned (MHz)
+     * \param bandWidth the width of the band to be returned
      *
      * \return the info corresponding to the band
      */
-    WifiSpectrumBandInfo GetPrimaryBand(uint16_t bandWidth) const;
+    WifiSpectrumBandInfo GetPrimaryBand(MHz_u bandWidth) const;
     /**
      * If the channel bonding is used, return the info corresponding to
      * the secondary channel of the given bandwidth (which must be a multiple of 20 MHz
      * and not exceed the operating channel width).
      *
-     * \param bandWidth the width of the band to be returned (MHz)
+     * \param bandWidth the width of the band to be returned
      *
      * \return the info corresponding to the band
      */
-    WifiSpectrumBandInfo GetSecondaryBand(uint16_t bandWidth) const;
+    WifiSpectrumBandInfo GetSecondaryBand(MHz_u bandWidth) const;
 
     /**
      * Return the channel width used to measure the RSSI.
      *
      * \param ppdu the PPDU that is being received
-     * \return the channel width (in MHz) used for RSSI measurement
+     * \return the channel width used for RSSI measurement
      */
-    virtual uint16_t GetMeasurementChannelWidth(const Ptr<const WifiPpdu> ppdu) const = 0;
+    virtual MHz_u GetMeasurementChannelWidth(const Ptr<const WifiPpdu> ppdu) const = 0;
 
     /**
      * Return the channel width used in the reception spectrum model.
      *
      * \param txVector the TXVECTOR of the PPDU that is being received
-     * \return the channel width (in MHz) used for RxSpectrumModel
+     * \return the channel width used for RxSpectrumModel
      */
-    virtual uint16_t GetRxChannelWidth(const WifiTxVector& txVector) const;
+    virtual MHz_u GetRxChannelWidth(const WifiTxVector& txVector) const;
 
     /**
-     * Return the delay until CCA busy is ended for a given sensitivity threshold (in dBm) and a
-     * given band.
+     * Return the delay until CCA busy is ended for a given sensitivity threshold and a given band.
      *
-     * \param thresholdDbm the CCA sensitivity threshold in dBm
+     * \param threshold the CCA sensitivity threshold
      * \param band identify the requested band
      * \return the delay until CCA busy is ended
      */
-    Time GetDelayUntilCcaEnd(double thresholdDbm, const WifiSpectrumBandInfo& band);
+    Time GetDelayUntilCcaEnd(dBm_u threshold, const WifiSpectrumBandInfo& band);
 
     /**
-     * \param currentChannelWidth channel width of the current transmission (MHz)
-     * \return the width of the guard band (MHz)
+     * \param currentChannelWidth channel width of the current transmission
+     * \return the width of the guard band
      *
      * Wrapper method used by child classes for PSD generation.
      * Note that this method is necessary for testing UL OFDMA.
      */
-    uint16_t GetGuardBandwidth(uint16_t currentChannelWidth) const;
+    MHz_u GetGuardBandwidth(MHz_u currentChannelWidth) const;
     /**
-     * \return a tuple containing the minimum rejection (in dBr) for the inner band,
-     *                            the minimum rejection (in dBr) for the outer band, and
-     *                            the maximum rejection (in dBr) for the outer band
+     * \return a tuple containing the minimum rejection for the inner band,
+     *                            the minimum rejection for the outer band, and
+     *                            the maximum rejection for the outer band
      *                            for the transmit spectrum mask.
      *
      * Wrapper method used by child classes for PSD generation.
      */
-    std::tuple<double, double, double> GetTxMaskRejectionParams() const;
+    std::tuple<dBr_u, dBr_u, dBr_u> GetTxMaskRejectionParams() const;
 
     using CcaIndication =
         std::optional<std::pair<Time, WifiChannelListType>>; //!< CCA end time and its corresponding
@@ -985,7 +943,8 @@
     std::list<WifiMode> m_modeList; //!< the list of supported modes
 
     std::vector<EventId> m_endPreambleDetectionEvents; //!< the end of preamble detection events
-    std::vector<EventId> m_endOfMpduEvents; //!< the end of MPDU events (only used for A-MPDUs)
+    std::vector<EventId> m_endOfMpduEvents;   //!< the end of MPDU events (only used for A-MPDUs)
+    std::vector<EventId> m_endOfMacHdrEvents; //!< the end of MAC header events
 
     std::vector<EventId>
         m_endRxPayloadEvents; //!< the end of receive events (only one unless UL MU reception)
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/preamble-detection-model.cc ns-3.43/src/wifi/model/preamble-detection-model.cc
--- ns-3.42/src/wifi/model/preamble-detection-model.cc	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/preamble-detection-model.cc	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/preamble-detection-model.h ns-3.43/src/wifi/model/preamble-detection-model.h
--- ns-3.42/src/wifi/model/preamble-detection-model.h	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/preamble-detection-model.h	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2018 University of Washington
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Sébastien Deronne <sebastien.deronne@gmail.com>
  */
@@ -20,6 +9,8 @@
 #ifndef PREAMBLE_DETECTION_MODEL_H
 #define PREAMBLE_DETECTION_MODEL_H
 
+#include "wifi-units.h"
+
 #include "ns3/object.h"
 
 namespace ns3
@@ -43,14 +34,14 @@
      * A pure virtual method that must be implemented in the subclass.
      * This method returns whether the preamble detection was successful.
      *
-     * \param rssi the RSSI of the received signal (in Watts).
+     * \param rssi the RSSI of the received signal.
      * \param snr the SNR of the received signal in linear scale.
-     * \param channelWidth the channel width of the received signal in MHz.
+     * \param channelWidth the channel width of the received signal.
      *
      * \return true if the preamble has been detected,
      *         false otherwise
      */
-    virtual bool IsPreambleDetected(double rssi, double snr, double channelWidth) const = 0;
+    virtual bool IsPreambleDetected(dBm_u rssi, double snr, MHz_u channelWidth) const = 0;
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/qos-frame-exchange-manager.cc ns-3.43/src/wifi/model/qos-frame-exchange-manager.cc
--- ns-3.42/src/wifi/model/qos-frame-exchange-manager.cc	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/qos-frame-exchange-manager.cc	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -158,7 +147,7 @@
 }
 
 bool
-QosFrameExchangeManager::StartTransmission(Ptr<Txop> edca, uint16_t allowedWidth)
+QosFrameExchangeManager::StartTransmission(Ptr<Txop> edca, MHz_u allowedWidth)
 {
     NS_LOG_FUNCTION(this << edca << allowedWidth);
 
@@ -566,7 +555,9 @@
     {
         uint8_t tid = hdr.GetQosTid();
         hdr.SetQosEosp();
-        hdr.SetQosQueueSize(m_mac->GetQosTxop(tid)->GetQosQueueSize(tid, hdr.GetAddr1()));
+        hdr.SetQosQueueSize(
+            m_mac->GetQosTxop(tid)->GetQosQueueSize(tid,
+                                                    mpdu->GetOriginal()->GetHeader().GetAddr1()));
     }
     FrameExchangeManager::ForwardMpduDown(mpdu, txVector);
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/qos-frame-exchange-manager.h ns-3.43/src/wifi/model/qos-frame-exchange-manager.h
--- ns-3.42/src/wifi/model/qos-frame-exchange-manager.h	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/qos-frame-exchange-manager.h	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2020 Universita' degli Studi di Napoli Federico II
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Stefano Avallone <stavallo@unina.it>
  */
@@ -45,7 +34,7 @@
     QosFrameExchangeManager();
     ~QosFrameExchangeManager() override;
 
-    bool StartTransmission(Ptr<Txop> edca, uint16_t allowedWidth) override;
+    bool StartTransmission(Ptr<Txop> edca, MHz_u allowedWidth) override;
 
     /**
      * Recompute the protection and acknowledgment methods to use if the given MPDU
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/qos-txop.cc ns-3.43/src/wifi/model/qos-txop.cc
--- ns-3.42/src/wifi/model/qos-txop.cc	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/qos-txop.cc	2024-10-09 16:41:10.124656700 -0700
@@ -2,18 +2,7 @@
  * Copyright (c) 2006, 2009 INRIA
  * Copyright (c) 2009 MIRKO BANCHI
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  *          Mirko Banchi <mk.banchi@gmail.com>
@@ -664,16 +653,16 @@
     if (respHdr.GetStatusCode().IsSuccess())
     {
         NS_LOG_DEBUG("block ack agreement established with " << recipient << " tid " << +tid);
-        // A (destination, TID) pair is "blocked" (i.e., no more packets are sent)
-        // when an Add BA Request is sent to the destination. However, when the
-        // Add BA Request timer expires, the (destination, TID) pair is "unblocked"
-        // and packets to the destination are sent again (under normal ack policy).
-        // Thus, there may be a packet needing to be retransmitted when the
-        // Add BA Response is received. In this case, the starting sequence number
-        // shall be set equal to the sequence number of such packet.
+        // A (destination, TID) pair is "blocked" (i.e., no more packets are sent) when an
+        // Add BA Request is sent to the destination. However, when the Add BA Request timer
+        // expires, the (destination, TID) pair is "unblocked" and packets to the destination are
+        // sent again (under normal ack policy). Thus, there may be a packet with a sequence number
+        // already assigned waiting to be retransmitted (or being transmitted on another link)
+        // when the Add BA Response is received. In this case, the starting sequence number shall
+        // be set equal to the sequence number of such packet.
         uint16_t startingSeq = m_txMiddle->GetNextSeqNumberByTidAndAddress(tid, recipient);
         auto peekedItem = m_queue->PeekByTidAndAddress(tid, recipient);
-        if (peekedItem && peekedItem->GetHeader().IsRetry())
+        if (peekedItem && peekedItem->HasSeqNoAssigned())
         {
             startingSeq = peekedItem->GetHeader().GetSequenceNumber();
         }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/qos-txop.h ns-3.43/src/wifi/model/qos-txop.h
--- ns-3.42/src/wifi/model/qos-txop.h	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/qos-txop.h	2024-10-09 16:41:10.124656700 -0700
@@ -2,18 +2,7 @@
  * Copyright (c) 2006, 2009 INRIA
  * Copyright (c) 2009 MIRKO BANCHI
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mathieu Lacage <mathieu.lacage@sophia.inria.fr>
  *          Mirko Banchi <mk.banchi@gmail.com>
@@ -41,13 +30,13 @@
 class WifiTxParameters;
 
 /**
- * \brief Handle packet fragmentation and retransmissions for QoS data frames as well
- * as MSDU aggregation (A-MSDU) and block ack sessions, for a given access class.
+ * \brief Handles the packet queue and stores DCF/EDCA access parameters
+ * (one Txop per AC).
  * \ingroup wifi
  *
- * This class implements the packet fragmentation and retransmission policy for
- * QoS data frames. It uses the ns3::ChannelAccessManager helper class to decide
- * when to send a packet. Packets are stored in a ns3::WifiMacQueue until they can be sent.
+ * This class handles the packet queue and stores DCF/EDCA access
+ * parameters (one Txop per AC). It generates backoff values and stores the channel access status
+ * (not requested, requested, granted) for the corresponding DCF/EDCA and for each link.
  *
  * This queue contains packets for a particular access class.
  * Possibles access classes are:
@@ -57,17 +46,6 @@
  *   - AC_BK : background, TID = 1,2
  *
  * This class also implements block ack sessions and MSDU aggregation (A-MSDU).
- *
- * The fragmentation policy currently implemented uses a simple
- * threshold: any packet bigger than this threshold is fragmented
- * in fragments whose size is smaller than the threshold.
- *
- * The retransmission policy is also very simple: every packet is
- * retransmitted until it is either successfully transmitted or
- * it has been retransmitted up until the SSRC or SLRC thresholds.
- *
- * The RTS/CTS policy is similar to the fragmentation policy: when
- * a packet is bigger than a threshold, the RTS/CTS protocol is used.
  */
 
 class QosTxop : public Txop
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/qos-utils.cc ns-3.43/src/wifi/model/qos-utils.cc
--- ns-3.42/src/wifi/model/qos-utils.cc	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/qos-utils.cc	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 MIRKO BANCHI
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Authors: Mirko Banchi <mk.banchi@gmail.com>
  *          Cecchi Niccolò <insa@igeek.it>
@@ -152,21 +141,6 @@
     return AC_UNDEF;
 }
 
-uint8_t
-QosUtilsGetTidForPacket(Ptr<const Packet> packet)
-{
-    SocketPriorityTag qos;
-    uint8_t tid = 8;
-    if (packet->PeekPacketTag(qos))
-    {
-        if (qos.GetPriority() < 8)
-        {
-            tid = qos.GetPriority();
-        }
-    }
-    return tid;
-}
-
 uint32_t
 QosUtilsMapSeqControlToUniqueInteger(uint16_t seqControl, uint16_t endSequence)
 {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.42/src/wifi/model/qos-utils.h ns-3.43/src/wifi/model/qos-utils.h
--- ns-3.42/src/wifi/model/qos-utils.h	2024-05-29 15:29:47.204074000 -0700
+++ ns-3.43/src/wifi/model/qos-utils.h	2024-10-09 16:41:10.124656700 -0700
@@ -1,18 +1,7 @@
 /*
  * Copyright (c) 2009 MIRKO BANCHI
  *
- * This program is free software; you can redistribute it and/or modify
- * it under the terms of the GNU General Public License version 2 as
- * published by the Free Software Foundation;
- *
- * This program is distributed in the hope that it will be useful,
- * but WITHOUT ANY WARRANTY; without even the implied warranty of
- * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
- * GNU General Public License for more details.
- *
- * You should have received a copy of the GNU General Public License
- * along with this program; if not, write to the Free Software
- * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ * SPDX-License-Identifier: GPL-2.0-only
  *
  * Author: Mirko Banchi <mk.banchi@gmail.com>
  */
@@ -220,18 +209,6 @@
 
 /**
  * \ingroup wifi
- * If a QoS tag is attached to the packet, returns a value < 8.
- * A value >= 8 is returned otherwise.
- *
- * \param packet the packet to checked for a QoS tag
- *
- * \return a value less than 8 if QoS tag was present, a value >= 8
- *         is returned if no QoS tag was present
- */
-uint8_t QosUtilsGetTidForPacket(Ptr<const Packet> packet);
-
-/**
- * \ingroup wifi
  * Next function is useful to correctly sort buffered packets under block ack.
  * When an BAR is received from originator station, completed "old"
  * (see section 9.10.3 in IEEE 802.11e) packets must be forwarded up before "new" packets.
